﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsAppLR11
{
    public partial class FormCalc : Form
    {
        public FormCalc()
        {
            InitializeComponent();
        }

        bool Resulttablo = true;
        string operation = "";

        public void plustablo(char c)
        {
            if (Resulttablo)
                textBoxPoleRez.Text = "";
            if (textBoxPoleRez.Text == "0")
                textBoxPoleRez.Text = "";
            textBoxPoleRez.Text += c.ToString();
            Resulttablo = false;
        }

        private void runOperationTablo(string oper)
        {
            double tablo;
            if (oper == "")
                return;
            try
            {
                tablo = Convert.ToDouble(textBoxPoleRez.Text);
            }
            catch (System.FormatException)
            {
                MessageBox.Show("Операцію виконати неможливо", "Увага", MessageBoxButtons.OK, MessageBoxIcon.Error);
                textBoxPoleRez.Text = "0";
                return;
            }
            switch (oper)
            {
                case "sqrt":
                    if (tablo < 0)
                    {
                        MessageBox.Show("Операцію неможливо виконати", "Увага", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        textBoxPoleRez.Text = "0";
                        return;
                    }
                    tablo = Math.Sqrt(tablo);
                    break;
                case "%":
                    tablo *= 0.01;
                    break;
                case "1/x":
                    if (tablo == 0)
                    {
                        MessageBox.Show("Операція неможлива : Ділення на нуль", "Увага", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }
                    tablo = 1 / tablo;
                    break;
                case "+/-":
                    tablo *= -1;
                    break;
                case "pow(5)":
                    {
                        tablo = Math.Pow(tablo, 5);
                        break;
                    }
                case "sinx":
                    {
                        tablo = Math.Sin(tablo);
                        break;
                    }

            }
            textBoxPoleRez.Text = tablo.ToString();
            Resulttablo = true;
        }

        private void runOperationMemory()
        {
            double tablo, memory;
            if (operation == "")
                return;
            try
            {
                tablo = Convert.ToDouble(textBoxPoleRez.Text);
                memory = Convert.ToDouble(textBoxMemory.Text);
            }
            catch (System.FormatException)
            {
                MessageBox.Show("Операцію виконати неможливо", "Увага", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            switch (operation)
            {
                case "+":
                    tablo += memory;
                    memory = tablo;
                    break;
                case "-":
                    tablo = memory - tablo;
                    memory = tablo;
                    break;
                case "*":
                    tablo *= memory;
                    memory = tablo;
                    break;
                case "/":
                    MessageBox.Show("Операція неможлива : Ділення на нуль", "Увага", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    tablo = memory / tablo;
                    memory = tablo;
                    break;
                case "M+":
                    memory += tablo;
                    break;
                case "M-":
                    memory -= tablo;
                    break;
                case "MC":
                    memory = 0;
                    break;
                case "MR":
                    tablo = memory;
                    break;
                case "MT":
                    memory = tablo;
                    break;
                case "C":
                    tablo = 0;
                    memory = 0;
                    break;
            }
            operation = "";
            textBoxPoleRez.Text = tablo.ToString();
            textBoxMemory.Text = memory.ToString();
            Resulttablo = true;
        }

        private void button27_Click(object sender, EventArgs e)
        {
            textBoxPoleRez.Text = "0";
            textBoxMemory.Text = "0";
        }

        private void button15_Click(object sender, EventArgs e)
        {
            textBoxMemory.Text = "0";
        }

        public void button11_Click(object sender, EventArgs e)
        {
            plustablo('0');
        }

        private void button1_Click(object sender, EventArgs e)
        {
            plustablo('1');
        }

        private void button4_Click(object sender, EventArgs e)
        {
            plustablo('2');
        }

        private void button7_Click(object sender, EventArgs e)
        {
            plustablo('3');
        }

        private void button2_Click(object sender, EventArgs e)
        {
            plustablo('4');
        }

        private void button5_Click(object sender, EventArgs e)
        {
            plustablo('5');
        }

        private void button8_Click(object sender, EventArgs e)
        {
            plustablo('6');
        }

        private void button3_Click(object sender, EventArgs e)
        {
            plustablo('7');
        }

        private void button6_Click(object sender, EventArgs e)
        {
            plustablo('8');
        }

        private void button9_Click(object sender, EventArgs e)
        {
            plustablo('9');
        }

        private void button12_Click(object sender, EventArgs e)
        {
            if (Resulttablo)
                textBoxPoleRez.Text = "0";
            bool avaible = false;
            int i, len;
            len = textBoxPoleRez.Text.Length;
            for (i = 0; i < len; i++)
            {
                if (textBoxPoleRez.Text[i] == ',')
                {
                    avaible = true;
                    break;
                }
            }
            if (!avaible)
            {

                textBoxPoleRez.Text += ",";
                Resulttablo = false;
            }
        }

        private void button10_Click(object sender, EventArgs e)
        {
            runOperationTablo("+/-");
        }

        private void button26_Click(object sender, EventArgs e)
        {
            if (Resulttablo)
                textBoxPoleRez.Text = "0";
            else
                textBoxPoleRez.Text = textBoxPoleRez.Text.Substring(0, textBoxPoleRez.Text.Length - 1);
            if (textBoxPoleRez.Text == "")
                textBoxPoleRez.Text = "0";
            Resulttablo = false;
        }

        private void button24_Click(object sender, EventArgs e)
        {
            runOperationTablo("sqrt");
        }

        private void button23_Click(object sender, EventArgs e)
        {
            runOperationTablo("%");
        }

        private void button22_Click(object sender, EventArgs e)
        {
            runOperationTablo("1/x");
        }

        private void button16_Click(object sender, EventArgs e)
        {
            runOperationMemory();
            operation = "MR";
            runOperationMemory();
        }

        private void button14_Click(object sender, EventArgs e)
        {
            runOperationMemory();
            operation = "M+";
            runOperationMemory();
        }

        private void button13_Click(object sender, EventArgs e)
        {
            runOperationMemory();
            operation = "M-";
            runOperationMemory();
        }

        private void button20_Click(object sender, EventArgs e)
        {
            runOperationMemory();
            operation = "MT";
            runOperationMemory();
            operation = "+";
        }

        private void button21_Click(object sender, EventArgs e)
        {
            runOperationMemory();
        }

        private void button19_Click(object sender, EventArgs e)
        {
            runOperationMemory();
            operation = "MT";
            runOperationMemory();
            operation = "-";
        }

        private void button18_Click(object sender, EventArgs e)
        {
            runOperationMemory();
            operation = "MT";
            runOperationMemory();
            operation = "*";
        }

        private void button17_Click(object sender, EventArgs e)
        {
            runOperationMemory();
            operation = "MT";
            runOperationMemory();
            operation = "/";
        }

        private void button25_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void button29_Click(object sender, EventArgs e)
        {
            runOperationTablo("sinx");
        }

        private void button28_Click(object sender, EventArgs e)
        {
            runOperationTablo("pow(5)");
        }

        private void FormCalc_Load(object sender, EventArgs e)
        {
            ToolTip t = new ToolTip();
            t.SetToolTip(label1, "пам'ять містить попореднє число");
            t.SetToolTip(button25, "Завершити");
            t.SetToolTip(button27, "Стерти все");
            t.SetToolTip(button26, "Стерти символ");
            t.SetToolTip(button16, "Зчитати пам'ять");
            t.SetToolTip(button15, "Стерти пам'ять");
        }

        private void виконавToolStripMenuItem_Click(object sender, EventArgs e)
        {
            label2.Visible = true;
        }
    }
}
